
varying vec4 ShadowCoord;
varying vec4 diffuse, ambient;
varying vec3 normal, lightDir, halfVector;
  
// Ambient and diffuse scale factors.
const float As = 1.0 / 1.5;
const float Ds = 1.0 / 3.0;

void ppLightingVert()
{	
	normal = normalize(gl_NormalMatrix * gl_Normal);
	
	lightDir = normalize(vec3(gl_LightSource[0].position));

	halfVector = normalize(gl_LightSource[0].halfVector.xyz);
	
	diffuse = gl_FrontMaterial.diffuse * gl_LightSource[0].diffuse;
	ambient = gl_FrontMaterial.ambient * gl_LightSource[0].ambient;
	ambient += gl_LightModel.ambient * gl_FrontMaterial.ambient;	
} 

void main()
{
	// TODO: implement perspective Shadowmaps
    vec4 ecPosition = gl_ModelViewMatrix * gl_Vertex;
	vec3 ecPosition3 = (vec3(ecPosition)) / ecPosition.w;

    vec3 VP = gl_LightSource[0].position.xyz - ecPosition3;
	
    VP = normalize(VP);
    vec3 normalvec = normalize(gl_NormalMatrix * gl_Normal);
    
	ShadowCoord = gl_TextureMatrix[0] * gl_ModelViewMatrix * gl_Vertex;
	
	gl_TexCoord[2] = gl_TextureMatrix[2] * gl_MultiTexCoord2;
    
	ppLightingVert();
	
    gl_Position = ftransform();
	
}