varying vec3 normal;
varying vec3 view;    

void main (void)  
{  
   vec3 light = normalize(gl_LightSource[0].position.xyz - view);   
   vec3 eye = normalize(-view);
   vec3 reflection = normalize(-reflect(light, normal));  
 
   //calculate Ambient Term:  
   vec4 ambient = gl_FrontLightProduct[0].ambient;    

   //calculate Diffuse Term:  
   vec4 diffuse = gl_FrontLightProduct[0].diffuse * max(dot(normal, light), 0.0);
   diffuse = clamp(diffuse, 0.0, 1.0);     
   
   // calculate Specular Term:
   vec4 specular = gl_FrontLightProduct[0].specular 
                * pow(max(dot(reflection, eye), 0.0), 0.3 * gl_FrontMaterial.shininess);
   specular = clamp(specular, 0.0, 1.0); 

   // write Total Color:  
   gl_FragColor = gl_FrontLightModelProduct.sceneColor + ambient + diffuse + specular;
   gl_FragColor.a = gl_FrontMaterial.diffuse.a;
}
          