
uniform sampler2D DiffuseMap;
uniform bool diffuseStatus;

uniform samplerCube EnvMap;

varying vec3 reflected;

const float mixFactor = 0.45;

void main()
{
	vec3 envColor = vec3(textureCube(EnvMap, reflected));

	if(diffuseStatus)
	{
		if(gl_FrontMaterial.shininess > 10.0)
		{
			envColor = mix(envColor, texture2D(DiffuseMap, gl_TexCoord[2].xy), mixFactor);
		}
		else
		{
			envColor = mix(envColor, texture2D(DiffuseMap, gl_TexCoord[2].xy), 1.0);
		}
	}
	else
	{
		if(gl_FrontMaterial.shininess > 10.0)
			envColor = mix(envColor, gl_FrontMaterial.diffuse.rgb, mixFactor);
		else
			envColor = mix(envColor, gl_FrontMaterial.diffuse.rgb, 1.0);
	}
		
    gl_FragColor = vec4(envColor.rgb, gl_FrontMaterial.diffuse.a);
}