
varying vec4 diffuse, ambient;
varying vec3 normal, lightDir, halfVector;
  
// Ambient and diffuse scale factors.
const float As = 1.0 / 1.5;
const float Ds = 1.0 / 3.0;

void ppLightingVert()
{
	normal = normalize(gl_NormalMatrix * gl_Normal);
	
	lightDir = normalize(vec3(gl_LightSource[0].position));

	halfVector = normalize(gl_LightSource[0].halfVector.xyz);

	diffuse = gl_FrontMaterial.diffuse * gl_LightSource[0].diffuse;
	ambient = gl_FrontMaterial.ambient * gl_LightSource[0].ambient;
	ambient += gl_LightModel.ambient * gl_FrontMaterial.ambient;	
} 

void main()
{
	// TODO: implement perspective Shadowmaps
	
	gl_TexCoord[2] = gl_TextureMatrix[2] * gl_MultiTexCoord2;
    
	ppLightingVert();
	
    gl_Position = ftransform();
	
}